import QtQuick 2.0
import QtQuick.XmlListModel 2.0

import Ubuntu.Components 0.1
import Ubuntu.Components.ListItems 0.1 as ListItems
import Ubuntu.Components.Popups 0.1

import "databasemodule.js" as DB

Page {

    signal backRequst
    property string feedLink: ""

    /* 1. Loading data from database by url.
     * 2. Appending data to ListModel for displaying.
     */
    function loadEntriesByUrl(strUrl) {
        newsListModel.clear()
        var isAll = (feedLink === "")
        var entries = DB.loadEntries(feedLink, isAll)
//        var entries = DB.dbResult.rows
        for (var i = 0; i < entries.length; i++) {
            newsListModel.append({"title":entries.item(i).title,
                                     "pubDate":entries.item(i).pubDate,
                                     "content":entries.item(i).content,
                                     "description":entries.item(i).description,
                                     "hash":entries.item(i).hash})
        }
        console.log("Loaded entries by URL " + strUrl)
    }

    onFeedLinkChanged: {
        loadEntriesByUrl(feedLink)
    }

    tools: ToolbarActions {
        back {
            visible: true
            onTriggered: {
                console.log("Back triggered!")
                backRequst()
            }
        }
    }

    ListView {
        id: newsList

        clip: true
        anchors.fill: parent

        model: ListModel {
            id: newsListModel
        }

        delegate: ListItems.Subtitled {
            text: model.title
            subText: model.pubDate
            progression: true

            onPressAndHold: {

            }

            onClicked: {
                mainPageStack.push(singleEntryPage)
                singleEntryPage.content.loadHtml((model.content !== "")? model.content : model.description) // FIRST WAY
                // contentLabel.text = (model.content != "")? model.content : model.description // SECOND WAY
            }
        } // delegate
    } // ListView

    /* SECOND WAY OF DISPLAYING FEED. DOES NOT WORK ON MY QT5 LIBS, BUG */
    //    Flickable {
    //        id: tmpLabelFlick
    //        clip: true
    //        width: parent.width



    //        anchors {
    //            top: newsList.bottom
    //            bottom: parent.bottom
    //            margins: units.gu(1)
    //        }
    //        contentWidth: parent.width
    //        contentHeight: contentLabel.height

    //        Label {
    //            id: contentLabel

    //            // text: "Some text! <img src='avatar@8.png'/> Second part of the text!"
    //            text: "Some text! <img src='/home/qtros/splashScreen_256.png'/> Second part of the text!"
    //            wrapMode: Text.WordWrap
    //            width: parent.width
    //            textFormat: Text.RichText
    //        }
    //    }
}
